import sys

from bokeh.models.widgets import DataCube
from bokeh.plotting import figure

from mongo.get_conn import db_conn

class PoolCharts():
    def __init__(self):
        self.db = db_conn()


    def line_chart(self, title, field, limit):
        data = self.db.pool_db
        data = data.find({}).sort("date", -1).limit(limit)
        dates = []
        data_list = []
        date_count = {}
        for record in data:
            if field in record and record[field] != "None":
                if record["date"] not in dates:
                    print("new date record")
                    dates.append(record["date"])
                    data_list.append(float(record[field]))
                    print (dates)
                    print (data_list)
                else:
                    if record["date"] in date_count:
                        date_count[record["date"]] += 1
                    else:
                        date_count[record["date"]] = 2
                    print(len(data_list))
                    current_data = data_list[len(data_list) - 1]
                    data_list[len(data_list) - 1] = (float(record[field]) + current_data) / date_count[record["date"]]

        print(dates)
        print(data_list)

        p = figure(x_range=dates, height=250, title=title,
            toolbar_location=None, tools="")

        p.line(x=dates, y=data_list)

        p.xgrid.grid_line_color = None
        if not data_list:
            p.y_range.start = 0
        else:
            p.y_range.start = round(min(data_list) - 1)
        return p
